/[sysadmin-cookbook]/recepies/lxc/lxc-watchdog.sh
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Diff of /recepies/lxc/lxc-watchdog.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 181 by dpavlin, Tue Mar 16 17:39:28 2010 UTC revision 232 by dpavlin, Sun Oct 24 11:55:02 2010 UTC
# Line 1  Line 1 
1  #!/bin/sh  #! /bin/sh
2    ### BEGIN INIT INFO
3    # Provides:          lxc-watchdog
4    # Required-Start:    $remote_fs $named $network $time
5    # Required-Stop:     $remote_fs $named $network
6    # Required-Start:    
7    # Required-Stop:    
8    # Default-Start:     2 3 4 5
9    # Default-Stop:      0 1 6
10    # Short-Description: Manage Linux Containers startup/shutdown
11    # Description:       Uses clever inotify hack to monitor container's
12    #                    halt/reboot events watching /var/run/utmp
13    ### END INIT INFO
14    
15  # lxc-watchdog.sh  # Author: Dobrica Pavlinusic <dpavlin@rot13.org>
 #  
 # Dobrica Pavlinusic <dpavlin@rot13.org> 2010-03-15  
 #  
 # this script can be used to start/stop Linux containers  
 # using clever inotify hack to monitor halt/reboot from  
 # Tony Risinger posted to lxc-users mailing list  
16  #  #
17    # based on Tony Risinger post to lxc-users mailing list
18  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html
19    #
20    # Install with:
21    # ln -sf /srv/sysadmin-cookbook/recepies/lxc/lxc-watchdog.sh /etc/init.d/lxc-watchdog
22    # update-rc.d lxc-watchdog defaults
23    
24    
25  which inotifywait >/dev/null || apt-get install inotify-tools  which inotifywait >/dev/null || apt-get install inotify-tools
26    
 lxc_status() {  
         lxc-ls -1 | sort -u | xargs -i lxc-info -n {}  
 }  
27    
28  lxc_exists() {  lxc_exists() {
29          name=$1          name=$1
# Line 29  lxc_exists() { Line 37  lxc_exists() {
37    
38    
39  lxc_rootfs() {  lxc_rootfs() {
40          grep lxc.rootfs "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'          grep '^ *lxc\.rootfs *=' "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'
41    }
42    
43    lxc_hostname() {
44            inside=`cat $(lxc_rootfs $1)/etc/hostname`
45            config=`grep lxc.utsname /var/lib/lxc/$name/config | cut -d= -f2`
46            echo "$config [$inside]";
47    }
48    
49    lxc_ip() {
50            grep lxc.network.ipv4 /var/lib/lxc/$name/config | cut -d= -f2 ||
51            grep address $(lxc_rootfs $name)/etc/network/interfaces | sed 's/.*address //'
52    }
53    
54    lxc_status() {
55            ( find /var/lib/lxc/ -name "config" | cut -d/ -f5 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do
56                    boot="-"
57                    test -s /var/lib/lxc/$name/on_boot && boot="boot"
58                    echo "$name $status $boot $(lxc_rootfs $name) $(lxc_ip $name) $(lxc_hostname $name)"
59            done ) | column -t
60  }  }
61    
62    
# Line 40  cleanup_init_scripts() { Line 67  cleanup_init_scripts() {
67                  $rootfs/etc/rc?.d/*umountfs \                  $rootfs/etc/rc?.d/*umountfs \
68                  $rootfs/etc/rc?.d/*umountroot \                  $rootfs/etc/rc?.d/*umountroot \
69                  $rootfs/etc/rc?.d/*hwclock* \                  $rootfs/etc/rc?.d/*hwclock* \
70                    $rootfs/etc/rc?.d/*udev* \
71          2>/dev/null | xargs -i rm -v {}          2>/dev/null | xargs -i rm -v {}
72    
73            echo $1 > $rootfs/etc/hostname
74  }  }
75    
76    
77  setup_inittab() {  setup_inittab() {
78          rootfs=$(lxc_rootfs $1)          rootfs=$(lxc_rootfs $1)
79            remove=$2
80            add=$3
81    
82          # let container respond to kill -SIGPWR          # let container respond to kill -SIGPWR
83          inittab=$rootfs/etc/inittab          inittab=$rootfs/etc/inittab
84          powerfail="pw::powerfail:/sbin/init 0"          if test -e $inittab && ! grep "$add" ${inittab} >/dev/null ; then
85          if ! grep "$powerfail" ${inittab} >/dev/null ; then                  grep -v "$remove" ${inittab} > ${inittab}.new
86                  grep -v ::power ${inittab} > ${inittab}.new                  echo $add >> ${inittab}.new
                 echo $powerfail >> ${inittab}.new  
87                  mv ${inittab}.new ${inittab}                  mv ${inittab}.new ${inittab}
88                  echo "$initab modified"                  echo "$inittab modified with $add"
89          fi          fi
90    }
91    
92    
93    lxc_log() {
94            echo `date +%Y-%m-%dT%H:%M:%S` $*
95  }  }
96    
97    
98  lxc_stop() {  lxc_kill() {
99          name=$1          name=$1
100            sig=$2
101    
102          init_pid=`lxc-ps -C init -o pid | grep "^$name" | cut -d" " -f2-`          init_pid=`lxc-ps -C init -o pid | grep "^$name" | cut -d" " -f2-`
103          if [ -z "$init_pid" ] ; then          if [ -z "$init_pid" ] ; then
104                  lxc-info -n $name                  lxc-info -n $name
105                  exit 1                  exit 1
106          fi          fi
107          echo "$name stop $init_pid"          lxc_log "$name kill $sig $init_pid"
108          /bin/kill -SIGPWR $init_pid          /bin/kill $sig $init_pid
109          lxc-wait -n $name -s STOPPED  }
110    
111    lxc_stop() {
112            lxc_log "$name stop"
113            lxc_kill $name -SIGPWR
114            lxc-wait -n $name -s STOPPED
115            lxc_log "$name stoped"
116    #       rm -f /var/lib/lxc/${name}/on_boot
117  }  }
118    
119    
120  lxc_start() {  lxc_start() {
121          name=$1          name=$1
122            rootfs=$(lxc_rootfs $1)
123    
124            if [ ! -e $rootfs ] ; then
125                    echo "ERROR $name rootfs $rootfs not found"
126                    return
127            fi
128    
129          if ! lxc-info -n $name | grep RUNNING ; then          if ! lxc-info -n $name | grep RUNNING ; then
130                  echo "$name start"                  lxc_log "$name start"
131                  lxc-start -n $name -o /tmp/${name}.log -d                  lxc-start -n $name -o /tmp/${name}.log -d
132                  lxc-wait  -n $name -s RUNNING                  lxc-wait  -n $name -s RUNNING
133                  lxc-info  -n $name                  lxc-info  -n $name
134                    test -f /var/lib/lxc/${name}/on_boot || echo $name > /var/lib/lxc/${name}/on_boot
135          fi          fi
136  }  }
137    
# Line 91  name=$1 Line 140  name=$1
140  rootfs=$(lxc_rootfs $1)  rootfs=$(lxc_rootfs $1)
141    
142  while true; do  while true; do
         # time of 5 minutes on it JUST IN CASE...  
143          vps_utmp=${rootfs}/var/run/utmp          vps_utmp=${rootfs}/var/run/utmp
         inotifywait -qqt 300 ${vps_utmp}  
144          tasks=`wc -l < /cgroup/${name}/tasks`          tasks=`wc -l < /cgroup/${name}/tasks`
145          test -z "$tasks" && exit 1          test -z "$tasks" && exit 1
146          if [ "$tasks" -eq 1 ]; then          if [ "$tasks" -eq 1 ]; then
147    
148                  runlevel="$(runlevel ${vps_utmp})"                  runlevel="$(runlevel ${vps_utmp})"
149                  echo "# $name runlevel $runlevel"                  lxc_log "$name runlevel $runlevel"
150    
151                  case $runlevel in                  case $runlevel in
152                  N*)                  N*)
153                          # nothing for new boot state                          # nothing for new boot state
154                  ;;                  ;;
155                  ??0)                  ??0)
156                          echo "$name halt"                          lxc_log "$name halt"
157                          lxc-stop -n "${name}"                          lxc-stop -n "${name}"
158                          lxc-wait -n ${name} -s STOPPED                          lxc-wait -n ${name} -s STOPPED
159                          break                          break
160                  ;;                  ;;
161                  ??6)                  ??6)
162                          echo "$name reboot";                          lxc_log "$name reboot";
163                          lxc-stop -n ${name}                          lxc-stop -n ${name}
164                          lxc-wait -n ${name} -s STOPPED                          lxc-wait -n ${name} -s STOPPED
165                          lxc-start -d -n ${name} -o /tmp/${name}.log                          lxc-start -d -n ${name} -o /tmp/${name}.log
# Line 124  while true; do Line 171  while true; do
171                  ;;                  ;;
172                  esac                  esac
173          else          else
174                  echo "# $name $tasks tasks"                  lxc_log "$name $tasks tasks"
175          fi          fi
176    
177            # time of 5 minutes on it JUST IN CASE...
178            inotifywait -qqt 300 ${vps_utmp}
179  done  done
180    
181  echo "${name} exited"  lxc_log "$name watchdog exited"
182    
183    }
184    
185    
186    usage() {
187            echo "Usage: $0 {start|stop|restart|status|boot|disable} [name name ... ]" >&2
188            exit 3
189  }  }
190    
191    command_on_lxc() {
192    command=$1
193    shift
194    
195    echo "# $command $1"
196    
197  case "$1" in  case "$command" in
198    
199  start)  start)
200          lxc_exists $2          lxc_exists $1
201          cleanup_init_scripts $2          cleanup_init_scripts $1
202          setup_inittab $2          setup_inittab $1 ":respawn:/sbin/getty.*tty1"   "c1:12345:respawn:/sbin/getty 38400 tty1 linux"
203          lxc_start $2          setup_inittab $1 "::power"                      "p0::powerfail:/sbin/init 0"
204          ( nohup $0 watchdog $2 >> /tmp/$2.log ) &          setup_inittab $1 "::ctrlaltdel"                 "p6::ctrlaltdel:/sbin/init 6"
205          ;;          lxc_start $1
206  stop)          # give container 5 seconds to start more than one process
207          lxc_exists $2          ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &
208          lxc_stop $2          ;;
209          ;;  stop|halt)
210  status)          lxc_exists $1
211          lxc_status          lxc_stop $1
212          ;;          ;;
213  reload|force-reload|restart)  reload|force-reload|restart|reboot)
214          lxc_stop $2          lxc_kill $1 -SIGINT
         lxc_start $2  
215          ;;          ;;
216  watchdog)  watchdog)
217          lxc_watchdog $2          lxc_watchdog $1
218            ;;
219    boot)
220            echo $1 > /var/lib/lxc/$1/on_boot
221            ;;
222    disable)
223            echo -n > /var/lib/lxc/$1/on_boot
224          ;;          ;;
225  *)  *)
226          echo "Usage: $0 {start|stop|restart|status}" >&2          usage
         exit 3  
227          ;;          ;;
228    
229  esac  esac
230    
231    }
232    
233    command=$1
234    test -z "$command" && usage
235    test "$command" = "status" && lxc_status && exit
236    shift
237    
238    if [ -z "$1" ] ; then
239            ls /var/lib/lxc/*/on_boot | while read path ; do
240                    name=`echo $path | cut -d/ -f5`
241                    if [ "$command" != "start" -o "$command" = "start" -a -s $path ] ; then
242                            command_on_lxc $command $name
243                    else
244                            echo "# skip $command $name"
245                    fi
246            done
247    else
248            while [ ! -z "$1" ] ; do
249                    command_on_lxc $command $1
250                    shift
251            done
252    fi
253    

Legend:
Removed from v.181  
changed lines
  Added in v.232

  ViewVC Help
Powered by ViewVC 1.1.26